Qwt User's Guide: QwtPlotPicker Class Reference

Qwt User's Guide 6.2.0

Signals | Public Member Functions | Protected Member Functions | List of all members
QwtPlotPicker Class Reference

QwtPlotPicker provides selections on a plot canvas. More...

`#include <qwt_plot_picker.h>`

Inheritance diagram for QwtPlotPicker:

## Signals
void | selected (const QPointF &pos)
void | selected (const QRectF &rect)
void | selected (const QVector< QPointF > &pa)
void | appended (const QPointF &pos)
void | moved (const QPointF &pos)
Signals inherited from QwtPicker
void | activated (bool on)
void | selected (const QPolygon &polygon)
void | appended (const QPoint &pos)
void | moved (const QPoint &pos)
void | removed (const QPoint &pos)
void | changed (const QPolygon &selection)

## Public Member Functions
| QwtPlotPicker (QWidget *canvas)
| Create a plot picker. More...
virtual | ~QwtPlotPicker ()
| Destructor.
| QwtPlotPicker (QwtAxisId xAxisId, QwtAxisId yAxisId, QWidget *)
| QwtPlotPicker (QwtAxisId xAxisId, QwtAxisId yAxisId, RubberBand rubberBand, DisplayMode trackerMode, QWidget *)
virtual void | setAxes (QwtAxisId xAxisId, QwtAxisId yAxisId)
QwtAxisId | xAxis () const
| Return x axis.
QwtAxisId | yAxis () const
| Return y axis.
QwtPlot * | plot ()
const QwtPlot * | plot () const
QWidget * | canvas ()
const QWidget * | canvas () const
Public Member Functions inherited from QwtPicker
| QwtPicker (QWidget *parent)
| QwtPicker (RubberBand rubberBand, DisplayMode trackerMode, QWidget *)
virtual | ~QwtPicker ()
| Destructor.
void | setStateMachine (QwtPickerMachine *)
const QwtPickerMachine * | stateMachine () const
QwtPickerMachine * | stateMachine ()
void | setRubberBand (RubberBand)
RubberBand | rubberBand () const
void | setTrackerMode (DisplayMode)
| Set the display mode of the tracker. More...
DisplayMode | trackerMode () const
void | setResizeMode (ResizeMode)
| Set the resize mode. More...
ResizeMode | resizeMode () const
void | setRubberBandPen (const QPen &)
QPen | rubberBandPen () const
void | setTrackerPen (const QPen &)
QPen | trackerPen () const
void | setTrackerFont (const QFont &)
QFont | trackerFont () const
bool | isEnabled () const
bool | isActive () const
virtual bool | eventFilter (QObject *, QEvent *) override
| Event filter. More...
QWidget * | parentWidget ()
| Return the parent widget, where the selection happens.
const QWidget * | parentWidget () const
| Return the parent widget, where the selection happens.
virtual QPainterPath | pickArea () const
virtual void | drawRubberBand (QPainter *) const
virtual void | drawTracker (QPainter *) const
virtual QRegion | trackerMask () const
virtual QRegion | rubberBandMask () const
QPoint | trackerPosition () const
virtual QRect | trackerRect (const QFont &) const
QPolygon | selection () const
Public Member Functions inherited from QwtEventPattern
| QwtEventPattern ()
virtual | ~QwtEventPattern ()
| Destructor.
void | initMousePattern (int numButtons)
void | initKeyPattern ()
void | setMousePattern (MousePatternCode, Qt::MouseButton button, Qt::KeyboardModifiers=Qt::NoModifier)
void | setKeyPattern (KeyPatternCode, int key, Qt::KeyboardModifiers modifiers=Qt::NoModifier)
void | setMousePattern (const QVector< MousePattern > &)
| Change the mouse event patterns.
void | setKeyPattern (const QVector< KeyPattern > &)
| Change the key event patterns.
const QVector< MousePattern > & | mousePattern () const
const QVector< KeyPattern > & | keyPattern () const
QVector< MousePattern > & | mousePattern ()
QVector< KeyPattern > & | keyPattern ()
bool | mouseMatch (MousePatternCode, const QMouseEvent *) const
| Compare a mouse event with an event pattern. More...
bool | keyMatch (KeyPatternCode, const QKeyEvent *) const
| Compare a key event with an event pattern. More...

## Protected Member Functions
QRectF | scaleRect () const
QRectF | invTransform (const QRect &) const
QRect | transform (const QRectF &) const
QPointF | invTransform (const QPoint &) const
QPoint | transform (const QPointF &) const
virtual QwtText | trackerText (const QPoint &) const override
virtual QwtText | trackerTextF (const QPointF &) const
| Translate a position into a position string. More...
virtual void | move (const QPoint &) override
virtual void | append (const QPoint &) override
virtual bool | end (bool ok=true) override
Protected Member Functions inherited from QwtPicker
virtual QPolygon | adjustedPoints (const QPolygon &) const
| Map the pickedPoints() into a selection() More...
virtual void | transition (const QEvent *)
virtual void | begin ()
virtual void | remove ()
virtual bool | accept (QPolygon &) const
| Validate and fix up the selection. More...
virtual void | reset ()
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetWheelEvent (QWheelEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | widgetEnterEvent (QEvent *)
virtual void | widgetLeaveEvent (QEvent *)
virtual void | stretchSelection (const QSize &oldSize, const QSize &newSize)
virtual void | updateDisplay ()
| Update the state of rubber band and tracker label.
const QwtWidgetOverlay * | rubberBandOverlay () const
const QwtWidgetOverlay * | trackerOverlay () const
const QPolygon & | pickedPoints () const
Protected Member Functions inherited from QwtEventPattern
virtual bool | mouseMatch (const MousePattern &, const QMouseEvent *) const
| Compare a mouse event with an event pattern. More...
virtual bool | keyMatch (const KeyPattern &, const QKeyEvent *) const
| Compare a key event with an event pattern. More...

## Additional Inherited Members
Public Types inherited from QwtPicker
enum | RubberBand { NoRubberBand = 0 , HLineRubberBand , VLineRubberBand , CrossRubberBand , RectRubberBand , EllipseRubberBand , PolygonRubberBand , UserRubberBand = 100 }
enum | DisplayMode { AlwaysOff , AlwaysOn , ActiveOnly }
| Display mode. More...
enum | ResizeMode { Stretch , KeepSize }
Public Types inherited from QwtEventPattern
enum | MousePatternCode { MouseSelect1 , MouseSelect2 , MouseSelect3 , MouseSelect4 , MouseSelect5 , MouseSelect6 , MousePatternCount }
| Symbolic mouse input codes. More...
enum | KeyPatternCode { KeySelect1 , KeySelect2 , KeyAbort , KeyLeft , KeyRight , KeyUp , KeyDown , KeyRedo , KeyUndo , KeyHome , KeyPatternCount }
| Symbolic keyboard input codes. More...
Public Slots inherited from QwtPicker
void | setEnabled (bool)
| En/disable the picker. More...

## Detailed Description

QwtPlotPicker provides selections on a plot canvas.

QwtPlotPicker is a QwtPicker tailored for selections on a plot canvas. It is set to a x-Axis and y-Axis and translates all pixel coordinates into this coordinate system.

Definition at line 33 of file qwt_plot_picker.h.

## Constructor & Destructor Documentation

## ◆ QwtPlotPicker() [1/3]

QwtPlotPicker::QwtPlotPicker | ( | QWidget * | canvas | ) |
| explicit

Create a plot picker.

The picker is set to those x- and y-axis of the plot that are enabled. If both or no x-axis are enabled, the picker is set to QwtAxis::XBottom. If both or no y-axis are enabled, it is set to QwtAxis::YLeft.

Parameters

  canvas | Plot canvas to observe, also the parent object

See also
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

Definition at line 43 of file qwt_plot_picker.cpp.

## ◆ QwtPlotPicker() [2/3]

QwtPlotPicker::QwtPlotPicker | ( | QwtAxisId | xAxisId,
|  | QwtAxisId | yAxisId,
|  | QWidget * | canvas
| ) |  |
| explicit

Create a plot picker

Parameters

  xAxisId | X axis of the picker
  yAxisId | Y axis of the picker
  canvas | Plot canvas to observe, also the parent object

See also
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

Definition at line 76 of file qwt_plot_picker.cpp.

## ◆ QwtPlotPicker() [3/3]

QwtPlotPicker::QwtPlotPicker | ( | QwtAxisId | xAxisId,
|  | QwtAxisId | yAxisId,
|  | RubberBand | rubberBand,
|  | DisplayMode | trackerMode,
|  | QWidget * | canvas
| ) |  |
| explicit

Create a plot picker

Parameters

  xAxis | X axis of the picker
  yAxis | Y axis of the picker
  rubberBand | Rubber band style
  trackerMode | Tracker mode
  canvas | Plot canvas to observe, also the parent object

See also
  QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode
  QwtPlot::autoReplot(), QwtPlot::replot(), scaleRect()

Definition at line 98 of file qwt_plot_picker.cpp.

## Member Function Documentation

## ◆ append()

void QwtPlotPicker::append | ( | const QPoint & | pos | ) |
| overrideprotectedvirtual

Append a point to the selection and update rubber band and tracker.

Parameters

  pos | Additional point

See also
  isActive, begin(), end(), move(), appended()

Note
  The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 251 of file qwt_plot_picker.cpp.

## ◆ appended

void QwtPlotPicker::appended | ( | const QPointF & | pos | ) |
| signal

A signal emitted when a point has been appended to the selection

Parameters

  pos | Position of the appended point.

See also
  append(). moved()

## ◆ canvas() [1/2]

QWidget * QwtPlotPicker::canvas | ( |  | ) |

Returns
  Observed plot canvas

Definition at line 114 of file qwt_plot_picker.cpp.

## ◆ canvas() [2/2]

const QWidget * QwtPlotPicker::canvas | ( |  | ) | const

Returns
  Observed plot canvas

Definition at line 120 of file qwt_plot_picker.cpp.

## ◆ end()

bool QwtPlotPicker::end | ( | bool | ok = `true` | ) |
| overrideprotectedvirtual

Close a selection setting the state to inactive.

Parameters

  ok | If true, complete the selection and emit selected signals otherwise discard the selection.

Returns
  True if the selection has been accepted, false otherwise

Reimplemented from QwtPicker.

Reimplemented in QwtPlotZoomer.

Definition at line 280 of file qwt_plot_picker.cpp.

## ◆ invTransform() [1/2]

QPointF QwtPlotPicker::invTransform | ( | const QPoint & | pos | ) | const
| protected

Translate a point from pixel into plot coordinates

Returns
  Point in plot coordinates

See also
  transform()

Definition at line 367 of file qwt_plot_picker.cpp.

## ◆ invTransform() [2/2]

QRectF QwtPlotPicker::invTransform | ( | const QRect & | rect | ) | const
| protected

Translate a rectangle from pixel into plot coordinates

Returns
  Rectangle in plot coordinates

See also
  transform()

Definition at line 341 of file qwt_plot_picker.cpp.

## ◆ move()

void QwtPlotPicker::move | ( | const QPoint & | pos | ) |
| overrideprotectedvirtual

Move the last point of the selection

Parameters

  pos | New position

See also
  isActive, begin(), end(), append()

Note
  The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

Definition at line 266 of file qwt_plot_picker.cpp.

## ◆ moved

void QwtPlotPicker::moved | ( | const QPointF & | pos | ) |
| signal

A signal emitted whenever the last appended point of the selection has been moved.

Parameters

  pos | Position of the moved last point of the selection.

See also
  move(), appended()

## ◆ plot() [1/2]

QwtPlot * QwtPlotPicker::plot | ( |  | ) |

Returns
  Plot widget, containing the observed plot canvas

Definition at line 126 of file qwt_plot_picker.cpp.

## ◆ plot() [2/2]

const QwtPlot * QwtPlotPicker::plot | ( |  | ) | const

Returns
  Plot widget, containing the observed plot canvas

Definition at line 136 of file qwt_plot_picker.cpp.

## ◆ scaleRect()

QRectF QwtPlotPicker::scaleRect | ( |  | ) | const
| protected

Returns
  Normalized bounding rectangle of the axes

See also
  QwtPlot::autoReplot(), QwtPlot::replot().

Definition at line 149 of file qwt_plot_picker.cpp.

## ◆ selected [1/3]

void QwtPlotPicker::selected | ( | const QPointF & | pos | ) |
| signal

A signal emitted in case of QwtPickerMachine::PointSelection.

Parameters

  pos | Selected point

## ◆ selected [2/3]

void QwtPlotPicker::selected | ( | const QRectF & | rect | ) |
| signal

A signal emitted in case of QwtPickerMachine::RectSelection.

Parameters

  rect | Selected rectangle

## ◆ selected [3/3]

void QwtPlotPicker::selected | ( | const QVector< QPointF > & | pa | ) |
| signal

A signal emitting the selected points, at the end of a selection.

Parameters

  pa | Selected points

## ◆ setAxes()

void QwtPlotPicker::setAxes | ( | QwtAxisId | xAxisId,
|  | QwtAxisId | yAxisId
| ) |  |
| virtual

Set the x and y axes of the picker

Parameters

  xAxisId | X axis
  yAxisId | Y axis

Reimplemented in QwtPlotZoomer.

Definition at line 172 of file qwt_plot_picker.cpp.

## ◆ trackerText()

QwtText QwtPlotPicker::trackerText | ( | const QPoint & | pos | ) | const
| overrideprotectedvirtual

Translate a pixel position into a position string

Parameters

  pos | Position in pixel coordinates

Returns
  Position string

Reimplemented from QwtPicker.

Definition at line 203 of file qwt_plot_picker.cpp.

## ◆ trackerTextF()

QwtText QwtPlotPicker::trackerTextF | ( | const QPointF & | pos | ) | const
| protectedvirtual

Translate a position into a position string.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the double to string conversion is "%.4f".

Parameters

  pos | Position

Returns
  Position string

Definition at line 223 of file qwt_plot_picker.cpp.

## ◆ transform() [1/2]

QPoint QwtPlotPicker::transform | ( | const QPointF & | pos | ) | const
| protected

Translate a point from plot into pixel coordinates

Returns
  Point in pixel coordinates

See also
  invTransform()

Definition at line 383 of file qwt_plot_picker.cpp.

## ◆ transform() [2/2]

QRect QwtPlotPicker::transform | ( | const QRectF & | rect | ) | const
| protected

Translate a rectangle from plot into pixel coordinates

Returns
  Rectangle in pixel coordinates

See also
  invTransform()

Definition at line 354 of file qwt_plot_picker.cpp.